SystemOrganization addCategory: #ConfigurationOfBDDExtensions!

Object subclass: #ConfigurationOfBDDExtensions
	instanceVariableNames: 'project'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ConfigurationOfBDDExtensions'!

!ConfigurationOfBDDExtensions commentStamp: 'TudorGirba 12/9/2011 19:19' prior: 0!
ConfigurationOfBDDExtensions loadDevelopment!

!ConfigurationOfBDDExtensions classSide methodsFor: 'private' stamp: 'TudorGirba 12/9/2011 19:15'!
ensureMetacello
        "Bootstrap Gofer (if necessary), load latest mcz file for ConfigurationOfMetacello (using old 
         Gofer API), then load the latest version of Metacello itself."

        Smalltalk at: #MetacelloProject ifAbsent: [ | error |
                "list of repositories to try, in case primary repository is not accessible"
                (Array 
                        with: 'http://www.squeaksource.com/MetacelloRepository' 
                        with: 'http://seaside.gemstone.com/ss/metacello') do: [:repositoryUrl |
                                ([
                                        Smalltalk at: #Gofer ifAbsent: [
                                        "Current version of Gofer from which to bootstrap - as of 1.0-beta.21"
                                                self bootstrapPackage: 'Gofer-Core-lr.115' from: repositoryUrl ].
                                        Smalltalk at: #Gofer ifPresent: [:goferClass | | gofer |
                                                gofer := goferClass new
                                                        url: repositoryUrl;
                                                        yourself.
                                                [ gofer addPackage: 'ConfigurationOfMetacello' ] on: Warning do: [:ex | ex resume ].
                                                gofer load ]]
                                                        on: Error
                                                        do: [ :ex |
                                                                error := ex.
                                                                Transcript 
                                                                        cr; 
                                                                        show: 'failed ensureMetacello: ';
                                                                        show: ex description printString;
                                                                        show: '...retrying'.
                                                                "try again"
                                                                ex return: nil ]) ~~ nil
                                        ifTrue: [
                                                "load 'default' group of Metacello"
                                                (Smalltalk at: #ConfigurationOfMetacello) perform: #load.
                                                ^self ]].
                "shouldn't get here unless the load failed ... throw an error"
                self error: 'retry with alternate repository failed: ', error description printString ]! !

!ConfigurationOfBDDExtensions classSide methodsFor: 'metacello tool support' stamp: 'TudorGirba 12/9/2011 19:15'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfBDDExtensions classSide methodsFor: 'loading' stamp: 'TudorGirba 12/9/2011 19:18'!
loadDevelopment
	(self project version: #development) load! !

!ConfigurationOfBDDExtensions classSide methodsFor: 'accessing' stamp: 'TudorGirba 12/9/2011 19:15'!
project

	^self new project! !

!ConfigurationOfBDDExtensions methodsFor: 'baselines' stamp: 'SeanDeNigris 7/27/2012 12:03'!
baseline10: spec 
	<version: '1.0-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
		spec repository: 'http://www.squeaksource.com/BDDExtensions'.
		spec 
			package: 'BDDExtensions';
			package: 'MethodWrappers4' with: [
				spec repository: 'http://www.squeaksource.com/MethodWrappers'];
			package: 'Mock' with: [ 
				spec requires: 'MethodWrappers4' ].
		spec group: #Mocks with: #(Mock) ].
	
	spec for: #'pharo1.3.x' do: [
		spec
			package: 'BDDExtensions' with: [
				spec requires: 'Keymapping-Shortcuts' ];
			package: 'Keymapping-Shortcuts' with: [
				spec repository: 'http://www.squeaksource.com/ShortWays'] ].! !

!ConfigurationOfBDDExtensions methodsFor: 'symbolic versions' stamp: 'TudorGirba 12/9/2011 19:17'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.0-baseline'.
! !

!ConfigurationOfBDDExtensions methodsFor: 'accessing' stamp: 'TudorGirba 12/9/2011 19:15'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		self class ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project]! !

!ConfigurationOfBDDExtensions methodsFor: 'symbolic versions' stamp: 'TudorGirba 12/9/2011 19:18'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '1.0-baseline'! !
